using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Web.Services3;
using System.Xml;
using Microsoft.Web.Services3.Security.Tokens;
using Microsoft.Web.Services3.Security;
using Microsoft.Web.Services3.Design;
using System.Security.Cryptography.X509Certificates;
using ConexionPlatino.Properties;

namespace ConexionPlatino
{
    public class PlatinoPolicy : SoapFilter
    {

        public override SoapFilterResult ProcessMessage(SoapEnvelope envelope)
        {

            // Vamos a reordenar las entradas en la cabecera y a quitar las entradas
            // no necesarias
            
            XmlNode SecurityNode = envelope.Header["wsse:Security"];

            // Quitamos el TimeStamp 
            XmlNode TimestampNode = SecurityNode["wsu:Timestamp"];
            if (TimestampNode != null) SecurityNode.RemoveChild(TimestampNode);

            // Pasamos el BinarySecurityToken desde el body a el header
            XmlNode BinaryNode = SecurityNode["wsse:BinarySecurityToken"];
            if (BinaryNode != null)
            {
                XmlNode BinaryNodeClone = BinaryNode.Clone();
                SecurityNode.RemoveChild(BinaryNode);
                SecurityNode.AppendChild(BinaryNodeClone);
            }


            // Quitamos el TimeStamp de la firma
            XmlNode SignatureNode = SecurityNode["Signature"];
            if (SignatureNode != null)
            {
                XmlNode SignedNode = SignatureNode["SignedInfo"];
                if (SignedNode != null)
                {

                    for (int index = 0; index < SignedNode.ChildNodes.Count; index++)
                    {
                        XmlElement child =
                          SignedNode.ChildNodes[index] as XmlElement;

                        // find all FOO headers 
                        if (child != null && child.Name == "Reference")
                        {
                            string uri = child.GetAttribute("URI");
                            if (!String.IsNullOrEmpty(uri) && uri.Substring(0, 10) == "#Timestamp")
                            {
                                SignedNode.RemoveChild(child);
                                break;
                            }

                        }
                    }
                }


                XmlNode SignatureNodeClone = SignatureNode.Clone();
                SecurityNode.RemoveChild(SignatureNode);
                SecurityNode.AppendChild(SignatureNodeClone);
            }


            // Movemos el UsernameToken
            XmlNode UsernameTokenNode = SecurityNode["wsse:UsernameToken"];
            if (UsernameTokenNode != null)
            {
                XmlNode UsernameTokenNodeClone = UsernameTokenNode.Clone();
                SecurityNode.RemoveChild(UsernameTokenNode);
                SecurityNode.AppendChild(UsernameTokenNodeClone);
            }

            // Movemos el platinoHeaders
            XmlNode PlatinoTokenNode = envelope.Header["platino:platinoHeaders"];
            if (PlatinoTokenNode != null)
            {
                XmlNode PlatinoTokenNodeClone = PlatinoTokenNode.Clone();
                envelope.Header.RemoveChild(PlatinoTokenNode);
                envelope.Header.AppendChild(PlatinoTokenNodeClone);
            }

            return SoapFilterResult.Continue;
        }
    }


}
