using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using ConexionPlatino.FirmaServicio;
using Microsoft.Web.Services3.Security;
using Microsoft.Web.Services3.Design;

namespace ConexionPlatino
{
    public class PlatinofirmaServiceWse : firmaServiceWse
    {
        public PlatinofirmaServiceWse(string sUserSerialNumber, string sUsernameToken, string sPasswordUsernameToken, string[] nombre, string[] valores)
        {
            PlatinoSecurityAssertion customSecurity = new PlatinoSecurityAssertion(sUserSerialNumber, sUsernameToken, sPasswordUsernameToken, SignatureOptions.IncludeSoapBody, nombre, valores);
            Policy policy = new Policy();
            policy.Assertions.Add(customSecurity);
            policy.Assertions.Add(new PlatinoAssertion());

            this.SoapVersion = System.Web.Services.Protocols.SoapProtocolVersion.Soap11;
            this.RequireMtom = true;
            // Aplicar policy 
            this.SetPolicy(policy);
        }

        public PlatinofirmaServiceWse(string sUserSerialNumber, string sUsernameToken, string sPasswordUsernameToken, string[] nombre, string[] valores, bool includeSoapBody)
        {
            PlatinoSecurityAssertion customSecurity = null;
            if (includeSoapBody)
                customSecurity = new PlatinoSecurityAssertion(sUserSerialNumber, sUsernameToken, sPasswordUsernameToken, SignatureOptions.IncludeSoapBody, nombre, valores);
            else
                customSecurity = new PlatinoSecurityAssertion(sUserSerialNumber, sUsernameToken, sPasswordUsernameToken, SignatureOptions.IncludeNone, nombre, valores);
            Policy policy = new Policy();
            policy.Assertions.Add(customSecurity);
            policy.Assertions.Add(new PlatinoAssertion());

            this.SoapVersion = System.Web.Services.Protocols.SoapProtocolVersion.Soap11;
            this.RequireMtom = true;
            // Aplicar policy 
            this.SetPolicy(policy);
        }

        protected override WebResponse GetWebResponse(WebRequest request)
        {
            WebResponse response = base.GetWebResponse(request);
            // Si la respuesta es no MTOM como un error de SOAP, informe a la representacin 
            // que realmente no necesitan MTOM
            if (response.Headers[HttpResponseHeader.ContentType].ToLower().StartsWith("text/xml"))
            {
                this.RequireMtom = false;
            }

            return response;
        }

    }
}
