using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.IO;
using System.Runtime.InteropServices;
using System.Configuration;
using ConexionPlatino;
using System.Security.Cryptography.X509Certificates;
using ConexionPlatino.FirmaServicio;
using WindowsApplication1.Properties;
using Microsoft.Web.Services3.Security;
using ConexionPlatino.RegistroEntradaSalida;
using System.Security.Cryptography;
using System.Runtime.Remoting.Metadata.W3cXsd2001;
using ConexionPlatino.SGRDEServicio;





namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        string sUsernameToken;
        string sPasswordUsernameToken;
        string sUserSerialNumber;
        string sPasswordHiperreg;
        string sUserHiperreg;

        public Form1()
        {
            InitializeComponent();
            Settings config = Settings.Default;

            sUsernameToken = config.Platino_UsernameToken;

            sPasswordUsernameToken = config.Platino_PasswordUsernameToken;

            sUserSerialNumber = config.Platino_UserSerialNumber;

            sUserHiperreg = config.Platino_UserHiperreg;

            sPasswordHiperreg = config.Platino_PasswordHiperreg;

        }

        private void button1_Click(object sender, EventArgs e)
        {
            

            PlatinofirmaServiceWse p = new PlatinofirmaServiceWse(sUserSerialNumber, sUsernameToken, sPasswordUsernameToken,  null, null);
            
            UtilidadesPLatino utilidades = new UtilidadesPLatino();

            string[] filtro = (!string.IsNullOrEmpty(Settings.Default.Platino_IusserNames)) ? Settings.Default.Platino_IusserNames.Split(',') : null;
            CAPICOM.Certificate Cert = utilidades.SeleccionarCertificado(filtro);
            validacionCert.Text = "";
            informacionCert.Text = "";
            datosHiperreg.Text = "";
            validacionCert.Refresh();
            informacionCert.Refresh();
            datosHiperreg.Refresh();


            if (Cert == null)
            {
                MessageBox.Show("No elegido certificado.");
                return;
            }
            X509Store store = new X509Store(StoreName.My, StoreLocation.CurrentUser);
            store.Open(OpenFlags.ReadOnly);
            X509Certificate2Collection listaCert = store.Certificates.Find(X509FindType.FindBySerialNumber, Cert.SerialNumber.ToLower(), false);
            string scertificado = Convert.ToBase64String(listaCert[0].RawData);

            validateCert validaCert = new validateCert();
            validaCert.invokingApp = "PLATINO";
            validaCert.certificateString = scertificado;
            OperacionTxt.Text = "Validamos Certificado";
            OperacionTxt.Refresh();

            try
            {
                validateCertResponse resvalida = p.validateCert(validaCert);

                validacionCert.Text = "Cdigo " + Convert.ToString(resvalida.@return.code) + "\r\n" + resvalida.@return.description;
                validacionCert.Refresh();

                if (resvalida.@return.code != 6) return;

            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return;
            }

            getCertInfo getcert2 = new getCertInfo();
            getcert2.invokingApp = "PLATINO";
            getcert2.certificate = scertificado;
            OperacionTxt.Text = "Info Certificado";
            OperacionTxt.Refresh();
            try
            {
                string[][] t = p.getCertInfo(getcert2);

                for (short i = 0; i < t.GetLength(0); i++) informacionCert.Text += t[i][0] + ": " + t[i][1] + "\r\n";
                informacionCert.Refresh();

            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return;
            }

            PlatinoregistroWse r = new PlatinoregistroWse(sUserSerialNumber, sUsernameToken, sPasswordUsernameToken, null, null); 
            

            registrarEntrada ent = new registrarEntrada();

            // Convierte la clave a encriptar en array de Bytes (unicode UTF-16)
            UnicodeEncoding unicode = new UnicodeEncoding();
            byte[] bClave = unicode.GetBytes(sPasswordHiperreg);
            // Crea la hash y devuelve un array de bytes
            byte[] hash = new MD5CryptoServiceProvider().ComputeHash(bClave);
            // Construye el string en Base64 para retornarlo
            ent.password = Convert.ToBase64String(hash);
            ent.usuario = sUserHiperreg;
            normalizaDatosFirmados nor = new normalizaDatosFirmados();

            Asunto s = new Asunto();
            s.codigo = "";
            s.Text = new string[2];
            s.Text[0] = AsuntoTxt.Text;
            s.Text[1] = "Hola";
            nor.OrganismoSpecified = true;
            
            nor.Organismo = Convert.ToInt32(OrganismoTxt.Text);
            nor.Asunto = s;
            nor.Nombre_Remitente = RemiteTxt.Text;
            nor.Tipo_Transporte = "01";
            nor.Tipo_Documento = "N";
            nor.NIF_Remitente = NIFTxt.Text;
            nor.Fecha = DateTime.Today;

            normalizaDatosFirmadosResponse resnor =  r.normalizaDatosFirmados(nor);



            XmlDocument doc = new XmlDocument();
            string msg;
            if (String.IsNullOrEmpty(txtUrn.Text) || String.IsNullOrEmpty(txtHash.Text))
                msg = String.Format("<Organismo>{0}</Organismo><Asunto>{1}</Asunto><Nombre_Remitente>{2}</Nombre_Remitente><Tipo_Transporte>{3}</Tipo_Transporte><Tipo_Documento>{4}</Tipo_Documento><NIF_Remitente>{5}</NIF_Remitente><Fecha>{6}</Fecha><Documentos></Documentos>", nor.Organismo, nor.Asunto.Text[0], nor.Nombre_Remitente, nor.Tipo_Transporte, nor.Tipo_Documento, nor.NIF_Remitente, nor.Fecha.ToString("yyyy-MM-dd"));
            else
                msg = String.Format("<Organismo>{0}</Organismo><Asunto>{1}</Asunto><Nombre_Remitente>{2}</Nombre_Remitente><Tipo_Transporte>{3}</Tipo_Transporte><Tipo_Documento>{4}</Tipo_Documento><NIF_Remitente>{5}</NIF_Remitente><Fecha>{6}</Fecha><Documentos><Documento><Nombre>{7}</Nombre><Hash>{8}</Hash></Documento></Documentos>", nor.Organismo, nor.Asunto.Text[0], nor.Nombre_Remitente, nor.Tipo_Transporte, nor.Tipo_Documento, nor.NIF_Remitente, nor.Fecha.ToString("yyyy-MM-dd"), txtUrn.Text, txtHash.Text);
            XmlCDataSection cdata = doc.CreateCDataSection(msg);
            ent.datosFirmados = cdata;
            
            
            ent.Firma = utilidades.SignMsg(msg, Cert, true);

            if (String.IsNullOrEmpty(ent.Firma))
            {
                MessageBox.Show("Error al firmar.");
                return;
            }
            
            registrarEntradaResponse res2;
            OperacionTxt.Text = "Registrar Hiperreg";
            OperacionTxt.Refresh();
            try
            {
                res2 = r.registrarEntrada(ent);
                datosHiperreg.Text = "Nmero Registro:";
                for (short j = 0; j < res2.Justificante_Registro.Datos_Firmados.Nmero_Registro.Text.GetLength(0); j++)
                    datosHiperreg.Text += " " + res2.Justificante_Registro.Datos_Firmados.Nmero_Registro.Text[j];

                datosHiperreg.Text += "\r\nNmero Oficina: " + Convert.ToString(res2.Justificante_Registro.Datos_Firmados.Nmero_Registro.numOficina);
                datosHiperreg.Text += "\r\nOficina: " + Convert.ToString(res2.Justificante_Registro.Datos_Firmados.Nmero_Registro.oficina);
                datosHiperreg.Text += "\r\nOficina Specified: " + Convert.ToString(res2.Justificante_Registro.Datos_Firmados.Nmero_Registro.numOficinaSpecified);
                datosHiperreg.Text += "\r\nFecha Registro: " + res2.Justificante_Registro.Datos_Firmados.Fecha_Registro.ToString("dd-MM-yyyy"); ;
                datosHiperreg.Text += "\r\nHora Registro: " + res2.Justificante_Registro.Datos_Firmados.Hora_Registro.ToString("HH:mm:ss");
                datosHiperreg.Text += "\r\nSellado en Tiempo: " + Convert.ToBase64String(res2.Justificante_Registro.Datos_Firmados.Sellado_En_Tiempo);
                datosHiperreg.Refresh();

            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return;
            }

            OperacionTxt.Text = "Grabar Registro";
            OperacionTxt.Refresh();
            FileStream fs = File.Create("e:\\test.pdf");
            BinaryWriter bw = new BinaryWriter(fs);
            bw.Write(res2.Justificante_Registro.reciboPdf);
            bw.Close();
            fs.Close();

            OperacionTxt.Text = "Abrir pdf";
            OperacionTxt.Refresh();
            System.Diagnostics.Process pros = new System.Diagnostics.Process();
            pros.StartInfo.FileName = "e:\\test.pdf";
            pros.Start();
            OperacionTxt.Text = "FIN";
            OperacionTxt.Refresh();

            consultarEntrada con = new consultarEntrada();
            con.Consulta_Registro = new Consulta_Registro();
            con.Consulta_Registro.Ejercicio = 2010;
            con.Consulta_Registro.Nmero_Registro = Convert.ToInt32(res2.Justificante_Registro.Datos_Firmados.Nmero_Registro.Text[0]);
            con.Consulta_Registro.password = res2.Justificante_Registro.Otros_Datos.Solicitud_Registro.password;
            con.Consulta_Registro.usuario = res2.Justificante_Registro.Otros_Datos.Solicitud_Registro.usuario;

            consultarEntradaResponse res3 = r.consultarEntrada(con);

        }




        private void button2_Click(object sender, EventArgs e)
        {
            //// Policy                      
            DialogResult result = openFileDialog.ShowDialog();
            if (result != DialogResult.OK) return;

            string file = openFileDialog.FileName;
            FileInfo fi = new FileInfo(file);
            byte[] b = new byte[fi.Length];
            b = System.IO.File.ReadAllBytes(file);

           
            // Crea la hash y devuelve un array de bytes
            byte[] hash = new MD5CryptoServiceProvider().ComputeHash(b);
            // Construye el string en Base64 para retornarlo
            txtHash.Text = Convert.ToBase64String(hash);
           


            //// Policy             
            
            PlatinoSGRDEServiceProxyWse p = new PlatinoSGRDEServiceProxyWse(sUserSerialNumber, sUsernameToken, sPasswordUsernameToken, null,null);
            
            InsertarDocumentoType documento = new InsertarDocumentoType();

            DocumentoSimple meta = new DocumentoSimple();
            
            documento.ruta = "solicitudes/P_2.6.8_2_0/" + Guid.NewGuid() + ".pdf";

            meta.Codigo_Aportado = "APORT_CIUD_EN_TRAM";
            meta.Desc_Aportado = "Aportado por el ciudadano";
            meta.Formato = "Formato";
            meta.Nivel_LOPD = "ALTO";
            meta.Acceso = "PUBLICO";
            meta.Tipo_Doc = "ALE";
            meta.Desc_Doc = "Descripcin del tipo de documento";
            meta.Admite_Versionado = false;
            meta.Tipo_Mime = "application/pdf";
            meta.Fecha_Doc = DateTime.Today;
            
            documento.documento = b;            
            FirmasElectronicas firmas = new FirmasElectronicas();

            try
            {
                string[] filtro = (!string.IsNullOrEmpty(Settings.Default.Platino_IusserNames)) ? Settings.Default.Platino_IusserNames.Split(',') : null;
                UtilidadesPLatino utilidades = new UtilidadesPLatino();
                
                // Firmamos el fichero Detached
                XmlElement elem= utilidades.FirmarFicheroEnveloped(file,  null, filtro);
                if( elem != null)
                    firmas.Firma = elem.OuterXml;
            }
            catch 
            {
                return;
            }
            
            meta.firmasElectronicas = firmas;    
            documento.metainformacion = meta;

            
            InsertarDocumentoResponseType res;

            try
            {
                res = p.insertarDocumento(documento);
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return;
            }
            txtUrn.Text = res.urn;
            txtUrn.Refresh();
            txtHash.Refresh();

            // Obtenemos el NDE
            try
            {
                ObtenerMetaDocType obdoc = new ObtenerMetaDocType();
                obdoc.id = res.urn;
                p.RequireMtom = true;
                ObtenerMetaDocResponseType res4 = p.obtenerMetaDoc(obdoc);
                txtNDE.Text = res4.metaInformacion.NDE;

            }
            catch (Exception exp1)
            {
                MessageBox.Show(exp1.Message);
                return;
            }
            
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            if (String.IsNullOrEmpty(txtNDE.Text)) return;

            DialogResult result = saveFileDialog.ShowDialog();
            if (result != DialogResult.OK) return;

            string file = saveFileDialog.FileName;


            PlatinoSGRDEServiceProxyWse p = new PlatinoSGRDEServiceProxyWse(sUserSerialNumber, sUsernameToken, sPasswordUsernameToken, null, null);
            
            ObtenerDocumentoNDEType obdoc = new ObtenerDocumentoNDEType();
            obdoc.NDE = txtNDE.Text;
            ObtenerDocumentoNDEResponseType res;

            try
            {
                res = p.obtenerDocumentoNDE(obdoc);
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return;
            }
                        
            FileStream fs = File.Create(file);
            BinaryWriter bw = new BinaryWriter(fs);
            bw.Write(res.documento);
            bw.Close();
            fs.Close();            
        }

        
        
     

     
    }


 
}